Merge branch 'release-2.140.109'
[feisty_meow.git] / scripts / rev_control / version_control.sh
index 8c1fbf27bcf4e61b828d0ecd7808a525a9a81bd6..b96bcb3431fe55aa4f7bb478bc85e3300a08cd6b 100644 (file)
@@ -3,19 +3,60 @@
 # these are helper functions for doing localized revision control.
 # this script should be sourced into other scripts that use it.
 
+# Author: Chris Koeritz
+# Author: Kevin Wentworth
+
 source "$FEISTY_MEOW_SCRIPTS/core/launch_feisty_meow.sh"
 source "$FEISTY_MEOW_SCRIPTS/tty/terminal_titler.sh"
 
+##############
+
+# check git version to see if we can use autostash.
+# this appears to be an ubuntu issue, where xenial did not provide it even though the
+# feature appeared in git 2.6 and xenial claims it has git version 2.7.4.  eventually,
+# this version test can go away.
+gitvertest="$(git version | sed -e 's/git version [0-9]\.//' | sed -e 's/\.[0-9][0-9]*$//' )"
+if (( $gitvertest >= 11 )); then
+  # auto-stash is not available until 2.6 for git, but ubuntu is misreporting or using a
+  # differing version number somehow.  we are sure autostash was missing on ubuntu xenial
+  # with git 2.7.4 and it's definitely present in zesty with git at 2.11.
+#  PULL_ADDITION='--rebase --autostash'
+#although initially attractive, above set of flags seems to lose history we don't want to
+#lose.
+PULL_ADDITION=
+fi
+
+##############
+
 # the maximum depth that the recursive functions will try to go below the starting directory.
 export MAX_DEPTH=5
 
-#hmmm: re-address this code, since it doesn't make a lot of sense to me right now...
+# use our splitter tool for lengthy output if it's available.
+if [ ! -z "$(which splitter 2>/dev/null)" ]; then
+  TO_SPLITTER="$(which splitter)"
+  # calculate the number of columsn in the terminal.
+  cols=$(get_maxcols)
+  TO_SPLITTER+=" --maxcol $(($cols - 1))"
+else
+  TO_SPLITTER=cat
+fi
+
+##############
+
+#hmmm: move this to core
+# this makes the status of pipe N into the main return value.
+function promote_pipe_return()
+{
+  ( exit ${PIPESTATUS[$1]} )
+}
+
+##############
+
 # one unpleasantry to take care of first; cygwin barfs aggressively if the TMP directory
 # is a DOS path, but we need it to be a DOS path for our GFFS testing, so that blows.
 # to get past this, TMP gets changed below to a hopefully generic and safe place.
-
 if [[ "$TMP" =~ .:.* ]]; then
-  echo making weirdo temporary directory for DOS path.
+  echo "making weirdo temporary directory for PCDOS-style path."
   export TMP=/tmp/rev_control_$USER
 fi
 if [ ! -d "$TMP" ]; then
@@ -26,96 +67,9 @@ if [ ! -d "$TMP" ]; then
   echo "this script will not work properly without an existing TMP directory."
 fi
 
-this_host=
-# gets the machine's hostname and stores it in the variable "this_host".
-function get_our_hostname()
-{
-  if [ "$OS" == "Windows_NT" ]; then
-    this_host=$(hostname)
-  elif [ ! -z "$(echo $MACHTYPE | grep apple)" ]; then
-    this_host=$(hostname)
-  elif [ ! -z "$(echo $MACHTYPE | grep suse)" ]; then
-    this_host=$(hostname --long)
-  else
-    this_host=$(hostname)
-  fi
-  #echo "hostname is $this_host"
-}
-
-# this function sets a variable called "home_system" to "true" if the
-# machine is considered one of fred's home machines.  if you are not
-# fred, you may want to change the machine choices.
-export home_system=
-function is_home_system()
-{
-  # load up the name of the host.
-  get_our_hostname
-  # reset the variable that we'll be setting.
-  home_system=
-  if [[ $this_host == *.gruntose.blurgh ]]; then
-    home_system=true
-#temp code
-elif [[ $this_host == buildy ]]; then
-home_system=true
-elif [[ $this_host == simmy ]]; then
-home_system=true
-#temp code
-  fi
-}
+##############
 
-#hmmm: move to core.
-# makes sure that the "folder" is a directory and is writable.
-# remember that bash successful returns are zeroes...
-function test_writeable()
-{
-  local folder="$1"; shift
-  if [ ! -d "$folder" -o ! -w "$folder" ]; then return 1; fi
-  return 0
-}
-
-# we only want to totally personalize this script if the user is right.
-function check_user()
-{
-  if [ "$USER" == "fred" ]; then
-    export SVNUSER=fred_t_hamster@
-    export EXTRA_PROTOCOL=+ssh
-  else
-    export SVNUSER=
-    export EXTRA_PROTOCOL=
-  fi
-}
-
-# calculates the right modifier for hostnames / repositories.
-modifier=
-function compute_modifier()
-{
-  modifier=
-  directory="$1"; shift
-  in_or_out="$1"; shift
-  check_user
-  # some project specific overrides.
-  if [[ "$directory" == hoople* ]]; then
-    modifier="svn${EXTRA_PROTOCOL}://${SVNUSER}svn.code.sf.net/p/hoople2/svn/"
-  fi
-  if [[ "$directory" == yeti* ]]; then
-    modifier="svn${EXTRA_PROTOCOL}://${SVNUSER}svn.code.sf.net/p/yeti/svn/"
-  fi
-  # see if we're on one of fred's home machines.
-  is_home_system
-  # special override to pick local servers when at home.
-  if [ "$home_system" == "true" ]; then
-    if [ "$in_or_out" == "out" ]; then
-      # need the right home machine for modifier when checking out.
-#huhhh?      modifier="svn://shaggy/"
-      modifier=
-    else 
-      # no modifier for checkin.
-      modifier=
-    fi
-  fi
-}
-
-# selects the method for check-in based on where we are.
+# checks the directory provided into the revision control system repository it belongs to.
 function do_checkin()
 {
   local directory="$1"; shift
@@ -127,53 +81,77 @@ function do_checkin()
   if [ $nicedir == "." ]; then
     nicedir=$(\pwd)
   fi
-  local blatt="echo checking in '$nicedir'..."
+  local blatt="echo -n checking in '$nicedir'...  "
 
   do_update "$directory"
-  if [ $? -ne 0 ]; then
-    echo "repository update failed; this should be fixed before check-in."
-    return 1
-  fi
+  test_or_die "repository update--this should be fixed before check-in."
+
   pushd "$directory" &>/dev/null
-  local retval=0  # normally successful.
   if [ -f ".no-checkin" ]; then
     echo "skipping check-in due to presence of .no-checkin sentinel file."
   elif [ -d "CVS" ]; then
     if test_writeable "CVS"; then
       $blatt
       cvs ci .
-      retval=$?
+      test_or_die "cvs checkin"
     fi
   elif [ -d ".svn" ]; then
     if test_writeable ".svn"; then
       $blatt
       svn ci .
-      retval=$?
+      test_or_die "svn checkin"
     fi
   elif [ -d ".git" ]; then
     if test_writeable ".git"; then
       $blatt
-      # snag all new files.  not to everyone's liking.
-      git add --all .
-      retval=$?
-      # tell git about all the files and get a check-in comment.
-      git commit .
-      retval+=$?
-      # upload the files to the server so others can see them.
-      git push 2>&1 | grep -v "X11 forwarding request failed"
-      retval+=$?
+
+      # put all changed and new files in the commit.  not to everyone's liking.
+      git add --all . | $TO_SPLITTER
+      promote_pipe_return 0
+      test_or_die "git add all new files"
+
+      # see if there are any changes in the local repository.
+      if ! git diff-index --quiet HEAD --; then
+        # tell git about all the files and get a check-in comment.
+#hmmm: begins to look like, you guessed it, a reusable bit that all commit actions could enjoy.
+        git commit .
+        retval=$?
+        test_or_continue "git commit"
+        if [ $retval -ne 0 ]; then
+          echo -e -n "Commit failed or was aborted:\nShould we continue with other check-ins? [y/N] "
+          local line
+          read line
+          if [[ "${line:0:1}" != "y" ]]; then
+            echo "Stopping check-in process due to missing commit and user request."
+            exit 1
+          fi
+        fi
+      fi
+
+      # a new set of steps we have to take to make sure the branch integrity is good.
+      do_careful_git_update "$(\pwd)"
+
+      # we continue on to the push, even if there were no changes this time, because
+      # there could already be committed changes that haven't been pushed yet.
+
+      # upload any changes to the upstream repo so others can see them.
+      git push --tags origin "$(my_branch_name)" 2>&1 | grep -v "X11 forwarding request failed" | $TO_SPLITTER
+      promote_pipe_return 0
+      test_or_die "git push"
+
     fi
   else
+    # nothing there.  it's not an error though.
     echo no repository in $directory
-    retval=1
   fi
   popd &>/dev/null
 
   restore_terminal_title
 
-  return $retval
+  return 0
 }
 
+# shows the local changes in a repository.
 function do_diff
 {
   local directory="$1"; shift
@@ -181,24 +159,27 @@ function do_diff
   save_terminal_title
 
   pushd "$directory" &>/dev/null
-  local retval=0  # normally successful.
 
   # only update if we see a repository living there.
   if [ -d ".svn" ]; then
     svn diff .
+    test_or_die "subversion diff"
   elif [ -d ".git" ]; then
     git diff 
+    test_or_die "git diff"
   elif [ -d "CVS" ]; then
     cvs diff .
+    test_or_die "cvs diff"
   fi
 
   popd &>/dev/null
 
   restore_terminal_title
 
-  return $retval
+  return 0
 }
 
+# reports any files that are not already known to the upstream repository.
 function do_report_new
 {
   local directory="$1"; shift
@@ -206,7 +187,6 @@ function do_report_new
   save_terminal_title
 
   pushd "$directory" &>/dev/null
-  local retval=0  # normally successful.
 
   # only update if we see a repository living there.
   if [ -f ".no-checkin" ]; then
@@ -214,20 +194,20 @@ function do_report_new
   elif [ -d ".svn" ]; then
     # this action so far only makes sense and is needed for svn.
     bash $FEISTY_MEOW_SCRIPTS/rev_control/svnapply.sh \? echo
-    retval=$?
+    test_or_die "svn diff"
   elif [ -d ".git" ]; then
     git status -u
-    retval=$?
+    test_or_die "git status -u"
   fi
 
   popd &>/dev/null
 
   restore_terminal_title
 
-  return $retval
+  return 0
 }
 
-# checks in all the folders in a specified list.
+# checks in all the folders in the specified list.
 function checkin_list()
 {
   # make the list of directories unique.
@@ -245,14 +225,16 @@ function checkin_list()
     if [[ $outer =~ /.* ]]; then
       # yep, this path is absolute.  just handle it directly.
       if [ ! -d "$outer" ]; then continue; fi
-      do_checkin $outer
+      do_checkin "$outer"
+      test_or_die "running check-in (absolute) on path: $outer"
       sep 28
     else
       for inner in $list; do
         # add in the directory component to see if we can find the folder.
         local path="$inner/$outer"
         if [ ! -d "$path" ]; then continue; fi
-        do_checkin $path
+        do_checkin "$path"
+        test_or_die "running check-in (relative) on path: $path"
         sep 28
       done
     fi
@@ -261,25 +243,199 @@ function checkin_list()
   restore_terminal_title
 }
 
-# takes out the first few carriage returns that are in the input.
-function squash_first_few_crs()
+# does a careful git update on all the folders in the specified list.
+function puff_out_list()
 {
-  i=0
-  while read input_text; do
-    i=$((i+1))
-    if [ $i -le 5 ]; then
-      echo -n "$input_text  "
+  # make the list of directories unique.
+  local list="$(uniquify $*)"
+
+  save_terminal_title
+
+  # turn repo list back into an array.
+  eval "repository_list=( ${REPOSITORY_LIST[*]} )"
+
+  local outer inner
+
+#hmmm: once again, seeing some reusable code in this loop...
+  for outer in "${repository_list[@]}"; do
+    # check the repository first, since it might be an absolute path.
+    if [[ $outer =~ /.* ]]; then
+      # yep, this path is absolute.  just handle it directly.
+      if [ ! -d "$outer" ]; then continue; fi
+      do_careful_git_update "$outer"
+      test_or_die "running puff-out (absolute) on path: $outer"
+      sep 28
     else
-      echo $input_text
+      for inner in $list; do
+        # add in the directory component to see if we can find the folder.
+        local path="$inner/$outer"
+        if [ ! -d "$path" ]; then continue; fi
+        do_careful_git_update "$path"
+        test_or_die "running puff-out (relative) on path: $path"
+        sep 28
+      done
     fi
   done
-  if [ $i -le 3 ]; then
-    # if we're still squashing eols, make sure we don't leave them hanging.
-    echo
+
+  restore_terminal_title
+}
+
+#hmmm: to go below.
+### takes out the first few carriage returns that are in the input.
+##function squash_first_few_crs()
+##{
+  ##i=0
+  ##while read input_text; do
+    ##i=$((i+1))
+    ##if [ $i -le 5 ]; then
+      ##echo -n "$input_text  "
+    ##else
+      ##echo $input_text
+    ##fi
+  ##done
+  ##if [ $i -le 3 ]; then
+    ### if we're still squashing eols, make sure we don't leave them hanging.
+    ##echo
+  ##fi
+##}
+
+#hmmm: the below are git specific and should be named that way.
+
+function all_branch_names()
+{
+  echo "$(git branch -vv | cut -d ' ' -f2)"
+}
+
+# a helpful method that reports the git branch for the current directory's
+# git repository.
+function my_branch_name()
+{
+  echo "$(git branch -vv | grep '\*' | cut -d ' ' -f2)"
+}
+
+#this had a -> in it at one point for not matching, didn't it?
+# this reports the upstream branch for the current repo.
+##function parent_branch_name()
+##{
+  ##echo "$(git branch -vv | grep \* | cut -d ' ' -f2)"
+##}
+
+# reports the status of the branch by echoing one of these values:
+#   okay: up to date and everything is good.
+#   needs_pull: this branch needs to be pulled from origins.
+#   needs_push: there are unsaved changes on this branch to push to remote store.
+#   diverged: the branches diverged and are going to need a merge.
+# reference: https://stackoverflow.com/questions/3258243/check-if-pull-needed-in-git
+function check_branch_state()
+{
+  local branch="$1"; shift
+
+  if [ -z "$branch" ]; then
+    echo "No branch was passed to check branch state."
+    return 1
+  fi
+
+  local to_return=120  # unknown issue.
+
+  local local_branch=$(git rev-parse @)
+  local remote_branch=$(git rev-parse "$branch")
+  local merge_base=$(git merge-base @ "$branch")
+
+  local to_echo=
+  if [ "$local_branch" == "$remote_branch" ]; then
+    to_echo="okay"
+  elif [ "$local_branch" == "$merge_base" ]; then
+    to_echo="needs_pull"
+  elif [ "$remote_branch" == "$merge_base" ]; then
+    to_echo="needs_push"
+  else
+    to_echo="diverged"
+  fi
+
+  echo -n "$to_echo"
+
+  return $to_return
+}
+
+# only shows the branch state if it's not okay.
+# note that this is not the same as a conditional branch (ha ha).
+function show_branch_conditionally()
+{
+  local this_branch="$1"; shift
+
+  local state=$(check_branch_state "$this_branch")
+  if [ "$state" != "okay" ]; then
+    echo "=> branch '$this_branch' state is not clean: $state"
   fi
 }
 
-# selects the checkout method based on where we are (the host the script runs on).
+# the git update process just gets more and more complex when you bring in
+# branches, so we've moved this here to avoid having a ton of code in the
+# other methods.
+function do_careful_git_update()
+{
+  local directory="$1"; shift
+  pushd "$directory" &>/dev/null
+  test_or_die "changing to directory: $directory"
+
+  if [ ! -d ".git" ]; then
+    # we ignore if they're jumping into a non-useful folder, but also tell them.
+    echo "Directory is not a git repository: $directory"
+    return 0
+  fi
+
+  local this_branch="$(my_branch_name)"
+
+  show_branch_conditionally "$this_branch"
+
+  # first update all our remote branches to their current state from the repos.
+  git remote update | $TO_SPLITTER
+  promote_pipe_return 0
+  test_or_die "git remote update"
+
+  show_branch_conditionally "$this_branch"
+
+  # this code is now doing what i have to do when i repair the repo.  and it seems to be good so far.
+  # note that we allow the local branch to be merged with its remote counterpart; otherwise we would
+  # miss changes that happened elsewhere which should be seen in our local copy.
+  local branch_list=$(all_branch_names)
+  local bran
+  for bran in $branch_list; do
+#    echo "synchronizing remote branch: $bran"
+    git checkout "$bran" | $TO_SPLITTER
+    promote_pipe_return 0
+    test_or_die "git switching checkout to remote branch: $bran"
+
+    show_branch_conditionally "$this_branch"
+
+    remote_branch_info=$(git ls-remote --heads origin $bran 2>/dev/null)
+    if [ ! -z "$remote_branch_info" ]; then
+      # we are pretty sure the remote branch does exist.
+      git pull --tags $PULL_ADDITION origin "$bran" | $TO_SPLITTER
+# we may want to choose to do fast forward, to avoid crazy multiple merge histories
+# without any changes in them.  --no-ff
+      promote_pipe_return 0
+    fi
+    test_or_die "git pull of remote branch: $bran"
+  done
+  # now switch back to our branch.
+  git checkout "$this_branch" | $TO_SPLITTER
+  promote_pipe_return 0
+  test_or_die "git checking out our current branch: $this_branch"
+
+  # now pull down any changes in our own origin in the repo, to stay in synch
+  # with any changes from others.
+  git pull --tags $PULL_ADDITION --all | $TO_SPLITTER
+#is the above really important when we did this branch already in the loop?
+#it does an --all, but is that effective or different?  should we be doing that in above loop?
+# --no-ff   
+  promote_pipe_return 0
+  test_or_die "git pulling all upstream"
+
+  popd &>/dev/null
+}
+
+# gets the latest versions of the assets from the upstream repository.
 function do_update()
 {
   directory="$1"; shift
@@ -293,25 +449,28 @@ function do_update()
   fi
   local blatt="echo retrieving '$nicedir'..."
 
-  local retval=0  # plan on success for now.
   pushd "$directory" &>/dev/null
   if [ -d "CVS" ]; then
     if test_writeable "CVS"; then
       $blatt
-      cvs update . | squash_first_few_crs
-      retval=${PIPESTATUS[0]}
+      cvs update . | $TO_SPLITTER
+      promote_pipe_return 0
+      test_or_die "cvs update"
     fi
   elif [ -d ".svn" ]; then
     if test_writeable ".svn"; then
       $blatt
-      svn update . | squash_first_few_crs
-      retval=${PIPESTATUS[0]}
+      svn update . | $TO_SPLITTER
+      promote_pipe_return 0
+      test_or_die "svn update"
     fi
   elif [ -d ".git" ]; then
     if test_writeable ".git"; then
       $blatt
-      git pull 2>&1 | grep -v "X11 forwarding request failed" | squash_first_few_crs
-      retval=${PIPESTATUS[0]}
+      git pull --tags $PULL_ADDITION 2>&1 | grep -v "X11 forwarding request failed" | $TO_SPLITTER
+#ordinary pulls should be allowed to do fast forward: --no-ff 
+      promote_pipe_return 0
+      test_or_die "git pull of origin"
     fi
   else
     # this is not an error necessarily; we'll just pretend they planned this.
@@ -321,7 +480,7 @@ function do_update()
 
   restore_terminal_title
 
-  return $retval
+  return 0
 }
 
 # gets all the updates for a list of folders under revision control.
@@ -342,6 +501,7 @@ function checkout_list()
       # yep, this path is absolute.  just handle it directly.
       if [ ! -d "$outer" ]; then continue; fi
       do_update $outer
+      test_or_die "running update on: $path"
       sep 28
     else
       for inner in $list; do
@@ -349,6 +509,7 @@ function checkout_list()
         local path="$inner/$outer"
         if [ ! -d "$path" ]; then continue; fi
         do_update $path
+        test_or_die "running update on: $path"
         sep 28
       done
     fi
@@ -366,40 +527,55 @@ function generate_rev_ctrl_filelist()
   local dirhere="$( \cd "$(\dirname "$dir")" && /bin/pwd )"
   local tempfile=$(mktemp /tmp/zz_checkins.XXXXXX)
   echo >$tempfile
+  local additional_filter
   find $dirhere -follow -maxdepth $MAX_DEPTH -type d -iname ".svn" -exec echo {}/.. ';' >>$tempfile 2>/dev/null
   find $dirhere -follow -maxdepth $MAX_DEPTH -type d -iname ".git" -exec echo {}/.. ';' >>$tempfile 2>/dev/null
   # CVS is not well behaved like git and (now) svn, and we seldom use it anymore.
   popd &>/dev/null
+
+  # see if they've warned us not to try checking in within vendor hierarchies.
+  if [ ! -z "NO_CHECKIN_VENDOR" ]; then
+    sed -i -e '/.*\/vendor\/.*/d' "$tempfile"
+  fi
+
   local sortfile=$(mktemp /tmp/zz_checkin_sort.XXXXXX)
   sort <"$tempfile" >"$sortfile"
-  \rm "$tempfile"
   echo "$sortfile"
+  \rm "$tempfile"
 }
 
 # iterates across a list of directories contained in a file (first parameter).
 # on each directory name, it performs the action (second parameter) provided.
 function perform_revctrl_action_on_file()
 {
-
-#hmmm: this doesn't capture any error returns!
-
   local tempfile="$1"; shift
   local action="$1"; shift
 
   save_terminal_title
 
+  local did_anything=
+
   while read -u 3 dirname; do
-    if [ -z "$dirname" ]; then continue; fi
+    if [ -z "$dirname" ]; then
+      # we often have blank lines in the input file for some reason.
+      continue
+    fi
+    did_anything=yes
     pushd "$dirname" &>/dev/null
     echo "[$(pwd)]"
-    $action .
+    # pass the current directory plus the remaining parameters from function invocation.
+    $action . 
+    test_or_die "performing action $action on: $(pwd)"
     sep 28
     popd &>/dev/null
   done 3<"$tempfile"
 
+  if [ -z "$did_anything" ]; then
+    echo "There was nothing to do the action '$action' on."
+  fi
+
   restore_terminal_title
 
-  rm $tempfile
+  rm "$tempfile"
 }
 
-